#include <stdlib.h>
#include <stdio.h>
#include <games.h>
#include <graphics.h>


#define MAX_BOTS           30
#define START_BOTS         5
#define ADD_BOTS           2

#define WIDTH              30		//22
#define HEIGHT             14		//14
#define BLX                4
#define BLY                4

#define TOO_CLOSE          2


#pragma string name Bots 2 - By Dan
extern char spr_you[];
extern char spr_bad[];
extern char spr_exp[];

#asm
   ._spr_you
   defb  4,4
   defb  @01100000
   defb  @10010000
   defb  @10010000
   defb  @01100000

   ._spr_bad
   defb  4,4
   defb  @11110000
   defb  @11110000
   defb  @01100000
   defb  @11110000

   ._spr_exp
   defb  4,4
   defb  @10010000
   defb  @01100000
   defb  @10100000
   defb  @01010000
#endasm


//////////////////////////////////////////////////////////////////

char botx[ MAX_BOTS ];
char boty[ MAX_BOTS ];
char botalive[ MAX_BOTS ];

char x, y;
char level;
char num_bots;
char game_over;
char bots_left;

void init_bots()
{
   char i;

   for ( i = 1; i <= num_bots; i++ )
   {
      botx[i] = (int)(rand()%WIDTH);
      boty[i] = (int)(rand()%HEIGHT);
      botalive[i] = 1;

      if (botx[i] > (WIDTH - 1) ) botx[i] = WIDTH - 1;
      if (boty[i] > (HEIGHT - 1) ) boty[i] = HEIGHT - 1;
      if (botx[i] < 1 ) botx[i] = 1;
      if (boty[i] < 1 ) boty[i] = 1;

      if ( ( abs( botx[i] - x) <= TOO_CLOSE ) && (abs( boty[i] - y ) <= TOO_CLOSE ) )
         i--;
   }
}

void next_level()
{
   level++;
   num_bots += ADD_BOTS;

   x = (int)(WIDTH / 2 );
   y = (int)(HEIGHT / 2 );
   init_bots();


}

void draw_screen()
{
   char i;
   clg();

   //Draw bots
   for ( i = 1; i <= num_bots; i++ )
      if ( botalive[i] )
         putsprite( spr_or, (botx[i] * BLX) + BLX, (boty[i] * BLY) + BLY, spr_bad );
      else
         putsprite( spr_or, (botx[i] * BLX) + BLX, (boty[i] * BLY) + BLY, spr_exp );

   //Draw you
   putsprite( spr_or, (x * BLX) + BLX, (y * BLY) + BLY, spr_you );
}


void do_death()
{
   char xx, yy, sl;

   for ( xx = 1; xx <= WIDTH - 1; xx++ )
      for ( yy = 1; yy <= HEIGHT - 1; yy++ )
      {
         putsprite( spr_or, (xx * BLX), (yy * BLY), spr_bad );
         //for ( sl = 0; sl < 255; sl++ );
      }

      game_over = 1;
}

void do_bot_collision()
{
   char i, n;

   for ( i = 1; i <= num_bots; i++ )
   {
      if ( (botx[i] == x) && (boty[i] == y ) )
         do_death();
      for ( n = 1; n <= num_bots; n++ )
         if ( i != n )
            if ( (botx[i] == botx[n]) && (boty[i] == boty[n] ) )
               botalive[i] = botalive[n] = 0;
   }
}

void do_bot_ai()
{
   char i;

   bots_left = 0;
   for ( i = 1; i <= num_bots; i++ )
      if ( botalive[i] )
      {
         bots_left++;
         if ( botx[i] < x )   botx[i]++;
         if ( botx[i] > x )   botx[i]--;
         if ( boty[i] < y )   boty[i]++;
         if ( boty[i] > y )   boty[i]--;
      }
}

void do_player_input( char inkey )
{

   switch( inkey )
   {
      case 13:
         game_over = 1;
         break;
      case '7':
         x--;
         y--;
         break;
      case '9':
         x++;
         y--;
         break;
      case '1':
         x--;
         y++;
         break;
      case '3':
         x++;
         y++;
         break;
      case '8':
         y--;
         break;
      case '2':
         y++;
         break;
      case '4':
         x--;
         break;
      case '6':
         x++;
         break;
      case '5':
         x = (int)(rand()%WIDTH) + 1;
         y = (int)(rand()%HEIGHT) + 1;
   }

   if ( x < 1 ) x = 1;
   if ( y < 1 ) y = 1;

   if ( x > WIDTH - 1 ) x = WIDTH - 1;
   if ( y > HEIGHT - 1 ) y = HEIGHT - 1;
}

main()
{

   char inkey;

   game_over = 0;
   level = 0;
   num_bots = START_BOTS - ADD_BOTS;

	#asm
		call $4AB1	;_runindicoff
		call $49DC	;_flushallmenus
		call $4A82	;_clrScrn
	#endasm	
	printf("\n       Bots II\n\n     Written by\n   Daniel McKinnon\n\n      Ported by\n   Donald Straney");
	putsprite( spr_or, 15, 15, spr_bad );
	putsprite( spr_or, 110, 55, spr_bad );
	putsprite( spr_or, 5, 47, spr_you );
	while (getk()!='\n')
	{
	}


   next_level();

   while ( !game_over )
   {
      do_bot_ai();
      do_bot_collision();

      if ( bots_left <= 0 )
         next_level();

      draw_screen();

      inkey = getk();
      do_player_input( inkey );


   }
}

